package s3;

import java.awt.Image;
import java.util.ArrayList;


public class Animation {

	private ArrayList frames = new ArrayList();
	private int currFrameIndex;
	private long animTime;
	private long totalDuration;


	public void addFrame(Image image, long duration){
		totalDuration += duration;
		frames.add(new AnimFrame(image, totalDuration));
	}

	public void update(long elapsedTime){
		
		if (frames.size() > 1) {
			animTime += elapsedTime;

			if (animTime >= totalDuration) {
				animTime = animTime % totalDuration;
				currFrameIndex = 0;
			}

			while (animTime > getFrame(currFrameIndex).endTime) {
				currFrameIndex++;
			}
		}
	}

	public Image getImage(){
		return getFrame(currFrameIndex).image;
	}


	private AnimFrame getFrame(int i){
		return (AnimFrame)frames.get(i);
	}



	private class AnimFrame {
		Image image;
		long endTime;

		public AnimFrame(Image image, long endTime) {
			this.image = image;
			this.endTime = endTime;
		}
	}

}
