package s4;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.image.BufferStrategy;

import javax.swing.ImageIcon;
import javax.swing.JFrame;

import s3.Animation;

public class SpriteSample1 extends JFrame {

	private Image bgImage;
	private Sprite sprite;



	public void prepare(){
		bgImage = loadImage("image/bg.jpg");
		
		Image image1 = loadImage("image/img1.gif");
		Image image2 = loadImage("image/img2.gif");
		Image image3 = loadImage("image/img3.gif");
		
		Animation anim = new Animation();
		anim.addFrame(image1, 200);
		anim.addFrame(image2, 200);
		anim.addFrame(image1, 200);
		anim.addFrame(image2, 200);
		anim.addFrame(image3, 500);
		sprite = new Sprite(anim);
		sprite.setVelocityX(0.2f);
		sprite.setVelocityY(0.1f);
	}
	
	public void loopAnim(){
		
		createBufferStrategy(2);
		
		long startTime = System.currentTimeMillis();
		long nowTime = startTime;
		
		while(nowTime - startTime < 100 * 1000){

			long elapsedTime = System.currentTimeMillis() - nowTime;
			nowTime += elapsedTime;

			updateSprites(elapsedTime);
			
			BufferStrategy strategy = getBufferStrategy();
			Graphics g = strategy.getDrawGraphics();
			g.drawImage(bgImage, 0, 0, null);
			g.drawImage(sprite.getImage(), (int)sprite.getX(), (int)sprite.getY(), null);
			g.dispose();
			strategy.show();
			
			try {
				Thread.sleep(20);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
		}
	}


	private void updateSprites(long elapsedTime){
		
		if(sprite.getX() < 0){
			sprite.setVelocityX(Math.abs(sprite.getVelocityX()));
		}else if(sprite.getX() > 600){
			sprite.setVelocityX(-Math.abs(sprite.getVelocityX()));			
		}
		
		if(sprite.getY() < 0){
			sprite.setVelocityY(Math.abs(sprite.getVelocityY()));
		}else if(sprite.getY() > 400){
			sprite.setVelocityY(-Math.abs(sprite.getVelocityY()));
		}
		
		sprite.update(elapsedTime);
	}



	
	private Image loadImage(String path){
		return new ImageIcon(path).getImage();
	}
	

	public static void main(String[] args) {
		SpriteSample1 frame = new SpriteSample1();

		frame.prepare();

		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setSize(640, 480);
		frame.setVisible(true);

		frame.loopAnim();
	}
	



	
}
